Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodObject.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodObject.h	(revision 1058)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodObject.h	(revision 1526)
@@ -4,4 +4,6 @@
 namespace Geometry
 {
+	class IndexData;
+
 	class LodObject
 	{
@@ -13,4 +15,6 @@
 		uint32 GetUniqueID(void) const { return  uniqueID; }
 		virtual void GoToLod(Real)=0;
+		virtual Real GetCurrentLodFactor(void) const =0;
+		virtual Geometry::IndexData * GetIndexDataInterface(void)=0;
 
 	private:
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodStripsLibrary.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodStripsLibrary.h	(revision 1090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodStripsLibrary.h	(revision 1526)
@@ -34,13 +34,14 @@
 	typedef	struct
 	{
-		unsigned	long	strip;
-		char						position;
-		char						vertexRepetition;
-		char						edgeRepetition;
+		unsigned	long	strip; // change this to uint32
+		char		position;
+		char		vertexRepetition;
+		char		edgeRepetition;
+		char		obligatory;
 	}	LODRegisterType;
 
 	typedef struct
 	{
-		float			Vertex[3];
+		float		Vertex[3];
 		SmallInt	Next;
 	} VertexType;
@@ -130,10 +131,10 @@
 
 			//	Copa STL vectors to C arrays.
-			void	CopyVectors2Arrays();
+			void	CopyVectors2Arrays(void);
 
 			//	Loads Mesh.
 			void	LoadStripMesh(const LodStripsLibraryData *, Mesh *geomesh);
 
-			Geometry::CREATEINDEXDATAFUNC create_index_data_func;
+//			Geometry::CREATEINDEXDATAFUNC create_index_data_func;
 
 			//	Strips vector.
@@ -146,13 +147,18 @@
 			//Number of strips in each submesh
 			int* mStripsSubmesh;
+			bool delete_indexdata;
+			int *submesh_x_strip;
+			Real lodFactor;
+			IndexData *dataRetrievalInterface;
+			uint32 current_triangle_count;
 
 		public:
 
-			IndexData *dataRetrievalInterface;
+			IndexData *GetIndexDataInterface(void){ return dataRetrievalInterface; }
 			
 			/**	Constructor, receives as a parameter the name of the file
 			 * 	including the multiresolution object.
 			*/
-			LodStripsLibrary(const LodStripsLibraryData *, Mesh *geomesh, CREATEINDEXDATAFUNC idfun=NULL);
+			LodStripsLibrary(const LodStripsLibraryData *, Mesh *geomesh, IndexData * userindexdata = NULL);
 
 			/// Destructor.
@@ -182,4 +188,7 @@
 			uint32 GetTotalStripCount(void) const { return mTotalStrips; }
 			uint32 GetSubMeshtripCount(int submeshid) const { return mStripsSubmesh[submeshid]; }
+			uint32 GetCurrentTriangleCount(void) const { return current_triangle_count; }
+
+			virtual Real GetCurrentLodFactor(void) const { return lodFactor; }
 	};
 }
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodManager.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodManager.h	(revision 1310)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodManager.h	(revision 1526)
@@ -15,39 +15,42 @@
 #include "GeoVector3.h"
 #include "GeoLodObject.h"
-#include <map>
-#include <vector>
 
 namespace Geometry
 {
-	class lodobj_dist_node_t
-	{
-	public:
-		lodobj_dist_node_t(float dist, LodObject *o):dist2cam(dist),lodobj(o){ must_recalculate_distance=false; }
-		float dist2cam;
-		LodObject *lodobj;
-		bool must_recalculate_distance;
-		bool operator < (const lodobj_dist_node_t &o) const { return (dist2cam < o.dist2cam); }
-	};
+	class NodeContainer;	
+	class lodobj_node_t;
 
 	class LodManager
 	{	
 	public:
-		LodManager(float near, float far, const Geometry::Vector3 &campos);
-		void AddLodObj(LodObject*, const Geometry::Vector3 &);
-		void UpdateLOD(void);
+		LodManager(Real near, Real far, const Geometry::Vector3 &campos, int numslots=10);
+		~LodManager(void);
+		void AddLodObj(const std::string &name, LodObject*, const Geometry::Vector3 &);
+		void UpdateLOD(uint32 currFPS, uint32 targetFPS=30);
 		void UpdateCamera(const Geometry::Vector3 &);
 		void UpdateLODObjectPos(LodObject*,const Geometry::Vector3 &);
+
+		bool always_calculate_lod; // if true, there is no instant LOD changing
+		bool force_highest_lod; // if set to true, all objects will be set to their highest level of detail
+
 	private:
-		std::vector<lodobj_dist_node_t> lodobj_dists; // key: dist2cam for efficient distance finding
-		std::map<uint32,Geometry::Vector3> lodobj_pos; // map key: LodObject UniqueID for efficient ID-based finding
-		unsigned int targetFPS;
-		Vector3 camera_pos;
-		bool camera_changed;
+		NodeContainer *lodobj_container;
+		uint32 lasttime;
+		bool camera_changed, node_added;
 		float near_range, far_range;
-		float CalculateDistToCamera(const Geometry::Vector3 &) const;
 		float SelectRandomDistance(void) const;
-		void RecalculateDist(lodobj_dist_node_t & node);
+		void ChangeLOD(lodobj_node_t*,Real);
+		void ReallyGoToLOD(lodobj_node_t*,Real);
+
+		lodobj_node_t * FindMostSimilarRealLOD(const std::string &, Real desired_lod);
+
+		void MakeDiscipleOf(lodobj_node_t *master, lodobj_node_t *disciple);
+		void MakeIndependent(lodobj_node_t*);
+		void RemoveDiscipleFrom(LodObject *master, LodObject *disciple);
+		void UpdateDisciples(lodobj_node_t *master);
+		void DeleteMeFromMyMastersDiscipleList(lodobj_node_t *);
+		void ChangeMaster(lodobj_node_t *orig, lodobj_node_t *newmaster);
 	};
-};
+}
 
 #endif
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/leaf.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/leaf.h	(revision 1019)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/leaf.h	(revision 1526)
@@ -5,5 +5,5 @@
 {
 	public :
-    	int  vertsLeaf[4];// Array of pointers to vertices
+    	int  vertsLeaf[4]; // the four indices of the leaf
 		float  normal[3];
 		float  parentLeafCount;
@@ -30,5 +30,5 @@
 		Leaf (void); // default constructor
 		Leaf (const Leaf&); // Copy constructor
-		virtual ~Leaf (void); // Destructor
+//		virtual ~Leaf (void); // Destructor
 
 		float Distance (Leaf&);
@@ -36,3 +36,17 @@
 };
 
+// this class is used by the lodtreelibrary to represent a leaf
+class RuntimeLeaf
+{
+public:
+	RuntimeLeaf(void);
+	RuntimeLeaf (const RuntimeLeaf&); // Copy constructor
+
+   	int vertsLeaf[4]; // the four indices of the leaf
+	int childLeft;
+	int childRight;
+	int parent;
+	int root;
+};
+
 #endif
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/VertexData.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/VertexData.h	(revision 1325)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/VertexData.h	(revision 1526)
@@ -4,117 +4,21 @@
 namespace Geometry
 {
-	class VertexData
-	{
-	private:
-		unsigned int numverts;
-	public:
-		VertexData(unsigned int numv):numverts(numv){}
-		virtual ~VertexData(void){}
-
-		virtual void Begin(void)=0;
-		virtual void SetVertexCoord(unsigned int i, float x, float y, float z)=0;
-		virtual void SetVertexNormal(unsigned int i, float x, float y, float z)=0;
-		virtual void SetVertexTexCoord(unsigned int i, float x, float y)=0;
-		virtual void End(void)=0;	
-
-		virtual void GetVertexCoord(unsigned int i, float &x, float &y, float &z) const = 0;
-		virtual void GetVertexNormal(unsigned int i, float &x, float &y, float &z) const = 0;
-		virtual void GetVertexTexCoord(unsigned int i, float &x, float &y) const =0;
-
-		unsigned int GetNumVertices(void) const { return numverts; }
-	};
-
 	class IndexData
 	{
 	private:
-		unsigned int numinds, numvalidinds;
-		unsigned int current_submesh;
 	public:
-		IndexData(unsigned int numi):numinds(numi),numvalidinds(numi){ current_submesh=0; }
+		IndexData(void){}
 		virtual ~IndexData(void){}
 
-		virtual void Begin(void)=0;
+		virtual void Begin(unsigned int submesh, unsigned int numinds)=0;
 		virtual void SetIndex(unsigned int i, unsigned int index)=0;
 		virtual void End(void)=0;
 
-		virtual unsigned int GetIndex(unsigned int) const =0;
-		unsigned int GetNumMaxIndices(void) const { return numinds; }
-		unsigned int GetNumValidIndices(void) const { return numvalidinds; }
-		void SetNumValidIndices(unsigned int valid){ numvalidinds=valid; } // this should not be called from client applications
-		void SetCurrentSubmesh(unsigned int c){ current_submesh=c; }  // this should not be called from client applications
-		unsigned int GetCurrentSubmesh(void) const { return current_submesh; }
+		virtual void BorrowIndexData(const IndexData *)=0; // tells the application to use this IndexData. If the app must use its own IndexData the param will be NULL
 	};
 
-/*	class MultiIndexData
-	{
-	private:
-		unsigned int num_prims, num_total_inds, *num_max_inds, *num_valid_inds;
-	public:
-		MultiIndexData(unsigned int numprims, unsigned int *maxinds){
-			num_prims=numprims;
-			num_total_inds=0;
-			num_max_inds=new unsigned int[numprims];
-			num_valid_inds=new unsigned int[numprims];
-			for (unsigned int i=0; i<numprims; i++)
-			{
-				num_max_inds[i]=num_valid_inds[i]=maxinds[i];
-				num_total_inds += maxinds[i];
-			}
-		}
 
-		~MultiIndexData(void){
-			delete[] num_max_inds;
-			delete[] num_valid_inds;
-		}
-
-		virtual void Begin(void)=0;
-		virtual void SetIndex(unsigned int iprim, unsigned int i, unsigned int index)=0;
-		virtual void End(void)=0;
-
-		virtual unsigned int GetIndex(unsigned int iprim, unsigned int index) const =0;
-		unsigned int GetNumMaxIndices(unsigned int iprim) const { return num_max_inds[iprim]; }
-		unsigned int GetNumValidIndices(unsigned int iprim) const { return num_valid_inds[iprim]; }
-		void SetNumValidIndices(unsigned int iprim, unsigned int valid){ num_valid_inds[iprim]=valid; }
-		unsigned int GetNumPrims(void) const { return num_prims; }
-	};*/
-
-	typedef VertexData* CreateVertexDataFunc(unsigned int numv);
-	typedef CreateVertexDataFunc* CREATEVERTEXDATAFUNC;
-	typedef IndexData* CreateIndexDataFunc(unsigned int numi);
+/*	typedef IndexData* CreateIndexDataFunc(unsigned int numi);
 	typedef CreateIndexDataFunc* CREATEINDEXDATAFUNC;
-/*	typedef MultiIndexData* CreateMultiIndexDataFunc(unsigned int numprims, unsigned int *numi);
-	typedef CreateMultiIndexDataFunc* CREATEMULTIINDEXDATAFUNC;*/
-
-	class DefaultVertexData : public VertexData
-	{
-	private:
-		float *v, *n, *t;
-	public:
-		DefaultVertexData(unsigned int numv);
-		~DefaultVertexData(void);
-
-		virtual void Begin(void){}
-		virtual void SetVertexCoord(unsigned int i, float x, float y, float z){ 
-			v[i*3+0]=x; v[i*3+1]=y; v[i*3+2]=z; }
-		virtual void SetVertexNormal(unsigned int i, float x, float y, float z){
-			n[i*3+0]=x; n[i*3+1]=y; n[i*3+2]=z; }
-		virtual void SetVertexTexCoord(unsigned int i, float x, float y){ 
-			t[i*2+0]=x; t[i*2+1]=y; }
-
-		virtual void End(void){}
-
-		virtual void GetVertexCoord(unsigned int i, float &x, float &y, float &z) const { 
-			x=v[i*3+0]; 
-			y=v[i*3+1]; 
-			z=v[i*3+2];
-		}
-		virtual void GetVertexNormal(unsigned int i, float &x, float &y, float &z) const {x=n[i*3+0]; y=n[i*3+1]; z=n[i*3+2]; }
-		virtual void GetVertexTexCoord(unsigned int i, float &x, float &y) const {x=t[i*2+0]; y=t[i*2+1]; }
-
-		const float * GetVertexFloatBuffer(void) const { return v; }
-
-	};
-	VertexData *DefaultVertexDataCreator(unsigned int numv);
-
 
 	class DefaultIndexData : public IndexData
@@ -123,8 +27,9 @@
 		unsigned int *indices;
 	public:
-		DefaultIndexData(unsigned int numi);
+		DefaultIndexData(void){ indices=0; }
 		~DefaultIndexData(void);
 
-		virtual void Begin(void){}
+		virtual void Init(unsigned int);
+		virtual void Begin(unsigned int submesh, unsigned int numinds){}
 		virtual void SetIndex(unsigned int i, unsigned int index){ 
 			indices[i] = index; 
@@ -135,29 +40,7 @@
 			return indices[i];
 		}
-
+		virtual void BorrowIndexData(const IndexData *){}
 	};
-	IndexData *DefaultIndexDataCreator(unsigned int numi);
-
-/*	class DefaultMultiIndexData : public MultiIndexData
-	{
-	private:
-		unsigned int **indices;
-	public:
-		DefaultMultiIndexData(unsigned int numprims, unsigned int *numi);
-		~DefaultMultiIndexData(void);
-
-		virtual void Begin(void){}
-		virtual void SetIndex(unsigned int iprim, unsigned int i, unsigned int index){ 
-			indices[iprim][i] = index; 
-		}
-		virtual void End(void){}
-
-		virtual unsigned int GetIndex(unsigned int iprim, unsigned int i) const {
-			return indices[iprim][i];
-		}
-
-	};
-	MultiIndexData *DefaultMultiIndexDataCreator(unsigned int numprims, unsigned int *numi);
-*/
+	IndexData *DefaultIndexDataCreator(unsigned int numi);*/
 }
 
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshSimpSequence.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshSimpSequence.h	(revision 1007)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshSimpSequence.h	(revision 1526)
@@ -28,4 +28,14 @@
 	\n
 	*/
+
+	//	Vertex info.
+	struct	GeoVertex
+	{
+		Index	id;
+		Index	bonefrom;
+		Vector3	position;
+		Vector2 texcoord;
+		Vector3 normal;
+	};
 
 	class MeshSimplificationSequence: public Serializable
@@ -60,6 +70,9 @@
 				//	Indicates the the step is obligatory to execute
 				//	joined width the following step.
-				unsigned int obligatorio;
+				unsigned int obligatory;
 			};
+
+			//	Vertices added in simplification.
+			std::vector<GeoVertex>	mNewVertices;
 
 			// Name of mesh.
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodTreeLibrary.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodTreeLibrary.h	(revision 1090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodTreeLibrary.h	(revision 1526)
@@ -20,17 +20,8 @@
 	{
 	public:
-/*		LodTreeLibrary( const LodTreeLibrary &);
-		LodTreeLibrary(LodTreeLibrary*);*/
 		LodTreeLibrary(	const LodStripsLibraryData *,
 						const TreeSimplificationSequence *,
-						Geometry::Mesh *treeGeoMesh/*,
-						uint32 leafSubMeshID
-						/*std::string foliage_verts,
-						std::string foliage_leafs,
-						std::string foliage_simpl/*,
-						uint32 leafSubMeshID,
-						CREATEVERTEXDATAFUNC vdfun=NULL, 
-						CREATEINDEXDATAFUNC idfun=NULL,
-						CREATEMULTIINDEXDATAFUNC midfun=NULL*/); // throws a FileNotFound exception
+						Geometry::Mesh *treeGeoMesh,
+						Geometry::IndexData *user_indexdata);
 		~LodTreeLibrary(void);
 
@@ -48,4 +39,6 @@
 		// changes the lod of the entire object (trunk and leaves)
 		virtual void GoToLod(Real);
+		virtual Real GetCurrentLodFactor(void) const { return (currentFoliageLodFactor+trunk->GetCurrentLodFactor())*0.5f; }
+		virtual Geometry::IndexData * GetIndexDataInterface(void){ return dataRetrievalInterface; }
 
 		// new proposed functions
@@ -71,4 +64,7 @@
 		Geometry::LodStripsLibrary *trunk;
 		uint32 mLeavesSubMesh;
+		IndexData *dataRetrievalInterface;
+		bool delete_indexdata;
+		float currentFoliageLodFactor;
 	};
 }
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/auxiliar.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/auxiliar.h	(revision 993)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/auxiliar.h	(revision 1526)
@@ -24,5 +24,5 @@
 {
 	uint32	strip;
-	char		nP,nL1,nL2,obligatory;
+	char	nP,nL1,nL2,obligatory;
 } LODData;
 #pragma pack()
@@ -37,5 +37,5 @@
 	float Normal[3];
 	float TexCoords[2];
-	unsigned int obligatorio;
+	unsigned int obligatory;
 	int numMesh;
 	uint32 Next;
@@ -55,5 +55,5 @@
 	uint32				vLSNext;
 	uint32				vLS;
-	unsigned int	obligatorio;
+	unsigned int	obligatory;
 	float					x;
 	char					*cambio;
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodStripsConstructor.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodStripsConstructor.h	(revision 1078)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodStripsConstructor.h	(revision 1526)
@@ -124,5 +124,8 @@
 			//	Sort submesh bones.
 			void	sortBones();
-			
+
+			//	Add new vertices to mesh.
+			void AddNewVertices();
+	
 		public:
 
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodStripsLibrary.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodStripsLibrary.cpp	(revision 1325)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodStripsLibrary.cpp	(revision 1526)
@@ -15,8 +15,8 @@
 
 //-----------------------------------------------------------------------------
-//	Constructors.
-//-----------------------------------------------------------------------------
-LodStripsLibrary::LodStripsLibrary(const LodStripsLibraryData *lodstripsdata, Mesh *geomesh, CREATEINDEXDATAFUNC idfun)
-:create_index_data_func(idfun?idfun:DefaultIndexDataCreator)
+//	Constructor.
+//-----------------------------------------------------------------------------
+LodStripsLibrary::LodStripsLibrary(const LodStripsLibraryData *lodstripsdata, Mesh *geomesh, IndexData *userindexdata)
+//:dataRetrievalInterface(idfun?idfun:DefaultIndexDataCreator)
 {
 //	const	char	*name_of_file;
@@ -31,8 +31,13 @@
 	mGeoMesh = geomesh;
 
-	dataRetrievalInterface=NULL;
+	delete_indexdata=false;
+	dataRetrievalInterface=userindexdata;
+	
 	indices_x_submesh = NULL;
 	offsets_x_submesh = NULL;
 	mStripsSubmesh = NULL;
+	submesh_x_strip = NULL;
+	lodFactor=1.0f;
+	current_triangle_count=0;
 	
 	//	Loads the Level Of Detail file.
@@ -51,10 +56,10 @@
 
 //-----------------------------------------------------------------------------
-//	Destroyer.
+//	Destructor
 //-----------------------------------------------------------------------------
 LodStripsLibrary::~LodStripsLibrary()
 {
 	delete	[] mStrips;
-	if (dataRetrievalInterface)
+	if (delete_indexdata)
 		delete dataRetrievalInterface;
 	if (indices_x_submesh)
@@ -64,4 +69,6 @@
 	if (mStripsSubmesh)
 		delete[] mStripsSubmesh;
+	if (submesh_x_strip)
+		delete[] submesh_x_strip;
 }
 
@@ -75,26 +82,28 @@
 void LodStripsLibrary::GoToLod(float lodfactor)
 {
-	register	int							j;
-	register	int							offset;
-	long			int							i;
-	long			int							k;
-	long			int							b_change_ok	=	1;
-	unsigned long	int					lod;
-	long			int							t;
-	long			int							r;
-	long			int							next;
-	long			int							el1;
-	long			int							el2;
-	long			int							total_changes;
-	long			int							totalR;
-	SmallIntVector						*strip;
+	register	int				j;
+	register	int				offset;
+	long			int			i;
+	long			int			k;
+	long			int			b_change_ok	=	1;
+	unsigned long	int			lod;
+	long			int			t;
+	long			int			r;
+	long			int			next;
+	long			int			el1;
+	long			int			el2;
+	long			int			total_changes;
+	long			int			totalR;
+	SmallIntVector				*strip;
 	SmallIntVector::iterator	start;
-	uint32										return_value;
+
+	if (lodfactor<0.0f) lodfactor=0.0f;
+	if (lodfactor>1.0f) lodfactor=1.0f;
 
 	uint32 newLOD = (uint32)((1.0f - lodfactor) * mLods);
+
+	lodFactor=lodfactor;
+	LODRegisterType * lastLOD = mCurrentRegLOD;
     
-	//	Initialize the return value to the current LOD.
-	return_value	=	mCurrentLod;
-
 	if (newLOD != mCurrentLod)
 	{
@@ -103,7 +112,7 @@
 			//	Forwards.
 			//	Increments LOD.
-			for (lod = mCurrentLod; lod < newLOD; lod++)
-			{
-				next						=	mVertex[lod];
+			for (lod = mCurrentLod; lod < newLOD || lastLOD->obligatory==1; lod++)
+			{
+				next			=	mVertex[lod];
 				total_changes	=	mPChanges[lod];
 
@@ -111,7 +120,8 @@
 				{
 					//	Strip change.
-					t			=	mCurrentRegLOD->strip; 
+					t		=	mCurrentRegLOD->strip; 
 					strip	=	&(mStrips[t]);
 					start	=	strip->begin();				
+					int stripsize_ini = strip->size();
 				
 					//	Position.
@@ -120,6 +130,5 @@
 					for (j = totalR - 1; j >= 0; j--)
 					{
-						start[*mCurrentData]	=	next;
-						
+						start[*mCurrentData]	=	next;						
 						++mCurrentData;
 					}
@@ -160,7 +169,11 @@
 					}
 
+					lastLOD = mCurrentRegLOD;
 					mCurrentRegLOD++;
 					
 					mStripsChanges[t]	=	1;
+
+					int stripsize_end = strip->size();
+					indices_x_submesh[submesh_x_strip[t]] -= (stripsize_ini - stripsize_end);
 				
 				}
@@ -177,5 +190,5 @@
 			
 			//	Decrements LOD.
-			for (lod = mCurrentLod; lod > newLOD; lod--)
+			for (lod = mCurrentLod; lod > newLOD || lastLOD->obligatory==1; lod--)
 			{
 				total_changes	=	mPChanges[lod - 1];
@@ -186,4 +199,5 @@
 					strip	=	&(mStrips[t]);
 					start	=	mStrips[t].begin();
+					int stripsize_ini = strip->size();
 
 					//	L2.
@@ -232,9 +246,14 @@
 					}
 					
+					lastLOD = mCurrentRegLOD;
 					mCurrentRegLOD--;
 					mStripsChanges[t]	=	1;
+
+					int stripsize_end = strip->size();
+					indices_x_submesh[submesh_x_strip[t]] += (stripsize_end - stripsize_ini);
+
 				}			
 				
-				//	Update LOD.
+				//	Update LOD.				
 				mCurrentLod	=	lod - 1;
 			}
@@ -359,5 +378,5 @@
 //	Copy a STL vector to a C array.
 //-----------------------------------------------------------------------------
-void LodStripsLibrary::CopyVectors2Arrays()
+void LodStripsLibrary::CopyVectors2Arrays(void)
 {
 	SmallInt 					max;
@@ -400,6 +419,10 @@
 	//	Copy strips.
 //	unsigned int numDegenerated = 2*mTotalStrips - 2;
-	dataRetrievalInterface=create_index_data_func(total_strip_size/*+numDegenerated*/); // temporal!
-	dataRetrievalInterface->Begin();
+//	dataRetrievalInterface=create_index_data_func(total_strip_size,indexdata_user_data); // temporal!
+
+//	dataRetrievalInterface->Init(total_strip_size);
+/*	dataRetrievalInterface->numinds=total_strip_size;
+	dataRetrievalInterface->numvalidinds=total_strip_size;*/
+//	dataRetrievalInterface->Begin();
 
 	unsigned	int	ii = 0;
@@ -410,5 +433,5 @@
 		{
 			mStrips[i].push_back(mFileStrips[i][j]);
-			dataRetrievalInterface->SetIndex(ii,mFileStrips[i][j]);
+//			dataRetrievalInterface->SetIndex(ii,mFileStrips[i][j]);
 		}
 		
@@ -416,5 +439,5 @@
 		mStripsChanges[i]	=	0;
 	}
-	dataRetrievalInterface->End();
+//	dataRetrievalInterface->End();
 
 	for (unsigned	int	i = 0; i < mData.size(); i++)
@@ -459,12 +482,23 @@
 	indices_x_submesh = new int[geomesh->mSubMeshCount];
 	offsets_x_submesh = new int[geomesh->mSubMeshCount];
+
+	int totaltiras = 0;
+	for (unsigned int submesh = 0; submesh < geomesh->mSubMeshCount; submesh++)
+		for (unsigned int strip = 0; strip < geomesh->mSubMesh[submesh].mStripCount; strip++)
+			totaltiras++;
+
+	submesh_x_strip = new int[totaltiras];
+
+	int istrip = 0;
 	for (unsigned int submesh	=	0; submesh < geomesh->mSubMeshCount; submesh++)
 	{
 		geoSubMesh	=	&geomesh->mSubMesh[submesh];
+		indices_x_submesh[submesh] = 0;
 
 		//	For each one of the strips.
-		for (unsigned int strip = 0; strip < geoSubMesh->mStripCount; strip++)
+		for (unsigned int strip = 0; strip < geoSubMesh->mStripCount; strip++, istrip++)
 		{
 			// Insert an empty strip.
+			submesh_x_strip[istrip] = submesh;
 			t++;
 			strip_aux.clear();
@@ -499,5 +533,5 @@
 			int i;
 			i	= 0;
-			indices_x_submesh[submesh] = 0;
+			
 			if (submesh==0)
 				offsets_x_submesh[submesh] = 0;
@@ -592,7 +626,5 @@
 	
 	for (unsigned int i = 0; i < mLods; i++)
-	{
 		mPChanges[i] = p_changes[i];
-	}
 
 	mTotalVertices		=	int(mFileVertices.size());
@@ -603,5 +635,4 @@
 	//Copy the data to the structure we will use
 	CopyVectors2Arrays();
-//	}
 }
 
@@ -610,11 +641,12 @@
 	unsigned	int	ii	=	0;
 	
-	dataRetrievalInterface->Begin();
-
 	int	counter	= 0;
 	int	target_submesh	= 0;
 	size_t	strip_count	= 0;
-
-	dataRetrievalInterface->SetCurrentSubmesh(target_submesh);
+	unsigned int ii_submesh = 0;
+
+	dataRetrievalInterface->Begin(target_submesh, indices_x_submesh[target_submesh]);
+
+//	dataRetrievalInterface->SetCurrentSubmesh(target_submesh);
 
 	for (unsigned	int	i	=	0;	i < mTotalStrips;	i++,	strip_count++)
@@ -622,5 +654,5 @@
 		if (strip_count >= mGeoMesh->mSubMesh[target_submesh].mStripCount)
 		{
-			indices_x_submesh[target_submesh] = counter;
+//			indices_x_submesh[target_submesh] = counter;
 
 			if (target_submesh==0)
@@ -634,9 +666,12 @@
 
 			target_submesh++;
-			dataRetrievalInterface->SetCurrentSubmesh(target_submesh);
+			ii_submesh = 0;
+//			dataRetrievalInterface->SetCurrentSubmesh(target_submesh);
+			dataRetrievalInterface->End();
+			dataRetrievalInterface->Begin(target_submesh, indices_x_submesh[target_submesh]);
 		}
 		
 		int lastindex = -1;
-		for (SmallIntVector::iterator it=mStrips[i].begin(); it!=mStrips[i].end(); it++, ii++)
+		for (SmallIntVector::iterator it=mStrips[i].begin(); it!=mStrips[i].end(); it++, ii++, ii_submesh++)
 		{
 /*			// repeat the first index of the strip: degenerate
@@ -649,5 +684,5 @@
 			}*/
 			lastindex=*it;
-			dataRetrievalInterface->SetIndex(ii,*it);
+			dataRetrievalInterface->SetIndex(ii_submesh,*it);
 			counter++;
 		}
@@ -658,10 +693,10 @@
 		ii++;*/
 
-		dataRetrievalInterface->SetNumValidIndices(ii);
+//		dataRetrievalInterface->SetNumValidIndices(ii);
 	}
 
 	if (strip_count >= mGeoMesh->mSubMesh[target_submesh].mStripCount)
 	{
-		indices_x_submesh[target_submesh] = counter;
+//		indices_x_submesh[target_submesh] = counter;
 		if (target_submesh==0)
 			offsets_x_submesh[target_submesh] = 0;
@@ -673,5 +708,5 @@
 		strip_count = 0;
 		target_submesh++;
-		dataRetrievalInterface->SetCurrentSubmesh(target_submesh);
+//		dataRetrievalInterface->SetCurrentSubmesh(target_submesh);
 	}
 
